import time
import paramiko
import sys

class AUTODEMO:

    def __init__(self, mission, date, iter):
        self.mission = mission
        self.date = date
        self.remoteFolder = f"/home/igharbi/autodemo/irace/{self.mission}-auto_{self.date}_{iter}"
        self.sshCreateFolder()
        self.sshCopyFolder()

        self.demoFile = f"./argosFiles/{self.mission}-auto.argos"
        remotepath =  f"{self.remoteFolder}/mission-folder/{self.mission}-auto.argos"
        localpath = self.demoFile
        self.sshPut(localpath, remotepath)

    def sshPut(self, localpath, remotepath):
        failed = True
        while(failed):
            try:
                host = "majorana.ulb.ac.be"
                password = "Benzai7!"  
                username = "igharbi"
                ssh = paramiko.SSHClient()
                ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
                ssh.connect(hostname = host,username = username, password = password)
                sftp = ssh.open_sftp()
                sftp.put(localpath, remotepath)
                sftp.close()
                ssh.close()
                failed = False
            except:
                print(f"Failed to ssh put: \"{localpath}\"")
                time.sleep(1)

    def sshCreateFolder(self):
        failed = True
        while(failed):
            try:
                host = "majorana.ulb.ac.be"
                password = "Benzai7!"  
                username = "igharbi"
                ssh = paramiko.SSHClient()
                ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
                ssh.connect(hostname = host,username = username, password = password)
                sftp = ssh.open_sftp()
                stdin, stdout, stderr = ssh.exec_command(f"mkdir {self.remoteFolder}")
                sftp.close()
                ssh.close()
                failed = False
            except:
                print(f"SSH create folder failed")
                time.sleep(1)

    def sshCopyFolder(self):
        failed = True
        while(failed):
            try:
                host = "majorana.ulb.ac.be"
                password = "Benzai7!"  
                username = "igharbi"
                ssh = paramiko.SSHClient()
                ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
                ssh.connect(hostname = host,username = username, password = password)
                sftp = ssh.open_sftp()
                stdin, stdout, stderr = ssh.exec_command(f"cp -r /home/igharbi/autodemo/irace/AutoMoDe/* {self.remoteFolder}")
                sftp.close()
                ssh.close()
                if(len(stderr.readlines()) > 0):
                    failed = True
                else:
                    failed = False
            except:
                print(f"SSH copy folder failed")
                time.sleep(1)
        return stdout

    def sshCmd(self, cmd):
        failed = True
        while(failed):
            try:
                host = "majorana.ulb.ac.be"
                password = "Benzai7!"  
                username = "igharbi"
                ssh = paramiko.SSHClient()
                ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
                ssh.connect(hostname = host,username = username, password = password)
                sftp = ssh.open_sftp()
                stdin, stdout, stderr = ssh.exec_command(cmd)
                sftp.close()
                ssh.close()
                if(len(stderr.readlines()) > 0):
                    failed = True
                else:
                    failed = False
            except:
                print(f"SSH cmd: \"{cmd}\" failed")
                time.sleep(1)
        return stdout
        
if __name__ == '__main__':
    mission = sys.argv[1]
    date = sys.argv[2]
    number = sys.argv[3]
    for i in range(int(number)):
        autodemo = AUTODEMO(mission, date, i+1)
        autodemo.sshCmd(f"sbatch automode.slurm {autodemo.remoteFolder} 1")
        print(f"Launched iteration {i+1}")
        time.sleep(5)