from cProfile import label
import matplotlib.pyplot as plt
import pandas as pd
import json
import numpy as np
from numpy import linalg as LA
import sys
import matplotlib

plt.rcParams["figure.autolayout"] = True
plt.rcParams["figure.figsize"] = [15, 7]
matplotlib.rcParams['pdf.fonttype'] = 42
matplotlib.rcParams['ps.fonttype'] = 42
matplotlib.rcParams['font.family'] = 'serif'

if __name__ == '__main__':
    mission = sys.argv[1]
    date = sys.argv[2]   

    dfs = []

    for i in range(10):
        path = f"JSON/{mission}_{date}/{mission}_{date}_{i+1}.json"
        dictionary = json.load(open(path, 'r'))
        dfs.append(pd.DataFrame(dictionary))

    s=pd.concat([df['t'] for df in dfs],axis=1)
    print(s)
    mean=s.groupby(s.columns.values,axis=1).mean()
    std = s.std(axis=1)
    print(std)
    ax = mean.plot(linestyle='--', yerr=std, linewidth = 1.5, capsize = 4, legend=False)   
    #s.plot(ax=ax, label=f"experience")

    # i=1
    # ax = dfs[0]['t'].plot(label=f"experience {i}")
    # for df in dfs[1:]:
    #     i += 1
    #     df['t'].plot(ax=ax, label=f"experience {i}")
    #     #print(f"t: {df['t'].tolist()}")
    ax.set_xlabel("iteration")
    ax.set_ylabel("Distance to expert feature") 
    plt.title("Average convergence to the expert feature demonstration for CFA over 10 independent designs")
    matplotlib.pyplot.savefig("./marginPlot/cfa_marg.png")

    exit(0)

    figs, axs = plt.subplots(2,2)
    for df, ax, i in zip(dfs, axs.ravel(), range(4)):
        print(df["mu"])
        dfT = [list(i) for i in zip(*df["mu"])]
        print(dfT)
        print(len(dfT))
        for e in dfT:
            ax.plot(np.arange(len(e)), e)
            ax.set_xlabel("iteration")
            ax.set_ylabel("mu")
            ax.set_title(f"experiment {i+1}")
    figs.suptitle("Components of mu over iterations")
    plt.show()

    figs, axs = plt.subplots(2,2)
    for df, ax, i in zip(dfs, axs.ravel(), range(4)):
        print(df["w"])
        dfT = [list(i) for i in zip(*df["w"])]
        print(dfT)
        print(len(dfT))
        for e in dfT:
            ax.plot(np.arange(len(e)), e)
            ax.set_ylim([-0.3,0.7])
            ax.set_xlabel("iteration")
            ax.set_ylabel("w")
            ax.set_title(f"experiment {i+1}")
    figs.suptitle("Components of w over iterations")
    plt.show()

    for df in dfs:
        df['R'] = df.apply(lambda row: np.dot(np.array(row.w).T, np.array(row.mu)), axis=1)
    ax = dfs[0]['R'].plot()
    for df in dfs[1:]:
        df['R'].plot(ax=ax)
        print(f"R: {df['R'].tolist()}")
    ax.set_xlabel("iteration")
    ax.set_ylabel("Estimated reward")
    plt.title("Estimated reward over design process iterations")
    plt.show()

    for df in dfs:
        df['trueR'] = df.apply(lambda row: LA.norm(np.array(row.mu), ord=1), axis=1)
    ax = dfs[0]['trueR'].plot(label='_nolegend_')
    for df in dfs[1:]:
        df['trueR'].plot(ax=ax, label='_nolegend_')
        print(f"TrueR: {df['trueR'].tolist()}")
    TRN = float(dfBaseline['TR Naive'][0])
    TRI = float(dfBaseline['TR Irace'][0])
    ax.plot([i for i in range(len(dfs[0]))], [TRN for i in range(len(dfs[0]))], '--', label="naive")
    ax.plot([i for i in range(len(dfs[0]))], [TRI for i in range(len(dfs[0]))], '--', label="irace")
    ax.set_xlabel("iteration")
    ax.set_ylabel("True reward")
    plt.title("True reward over design process iterations")
    plt.legend()
    plt.show()



